﻿using System;
using System.Net;

namespace JaoWebServiceClient.Proxy
{
    public partial class MessageStoreImplService
    {
        protected override System.Net.WebRequest GetWebRequest(Uri uri)
        {
            var req = (HttpWebRequest)base.GetWebRequest(uri);
            if (Credentials == null) 
                throw new InvalidOperationException("Credentials should be set.");
            var credentials = Credentials.GetCredential(uri, "BASIC");
            var user = credentials.UserName;
            var pwd = credentials.Password;
            var auth = "Basic " + Convert.ToBase64String(System.Text.Encoding.Default.GetBytes(user + ":" + pwd));
            req.PreAuthenticate = true;
            req.AuthenticationLevel = System.Net.Security.AuthenticationLevel.MutualAuthRequested;
            req.Headers.Add("Authorization", auth);
            return req;

        }
    }
}